
#include "LCD_2x16_lib_X.h"

extern void Delay_20ms();

void  Pulse_En (void)
{
En = 1;
Delay_20ms();
En=0;
 __asm("    NOP");
 __asm("    NOP");
 }


void Init_Step(unsigned char cc)
{     Delay_20ms();
       PORT_Data=PORT_Data & 0x0f;              //clear port and shift left 4 times
     __asm("NOP");
    PORT_Data= PORT_Data | cc; // 0x30;	    //write lower nibble of cmd  to UPPERT port
    Pulse_En ();
}
 
 
void LCD_Cde(unsigned char cmd)
{
 Delay_20ms();
RS=0;
__asm("NOP");
En=0;
PORT_Data  &=0x0f;               //clear port
__asm("NOP");
PORT_Data  |= cmd&0xf0;          //write upper nibble of cmd to UPPERT port
__asm("NOP");
// Delay_20ms();
Pulse_En();
PORT_Data  &= 0x0f;              //clear port and shift left 4 times
__asm("NOP");
PORT_Data  |= (cmd<<4)&0xf0;	    //write lower nibble of cmd  to UPPERT port
 Delay_20ms();
Pulse_En ();
// Delay_20ms();
return;
}


void LCD_Pos(char L,char posX)
{
 if (L==1) LCD_Cde(0x80+posX);     // D7=1 + adresse D6..D0 = 0 a 15
 if (L==2) LCD_Cde(0xC0+posX);	    // D7=1 + offset 40H 2nd line + adress D6..D0 = 0 a 15

}


void Init_XC8_LCD ()
{  
   Delay_20ms();
   TRISB=TRISB & 0x0F;
   //TRISBbits.TRISB  = TRISBbits.TRISB &  0x0F; 
   // B0 ..B3 as input  B4..B7 as ouput
   __asm("NOP");
   PORT_Data &=0x0f;      //clear port
   Delay_20ms();
   RW=0;
   RS=0;
   En=0;
  
    Init_Step(0x30);
    Init_Step(0x30);
    Init_Step(0x30);
    Init_Step(0x20);
    //Function SET Commande 0 0 1 DL N F X X  avec RS=0 RW=0
    //Definit la taille de l'interface (DL=0 pour mode 4 bits, DL=1 pour mode 8 bits),
    // le nombre de lignes (NL=0 pour 1 ligne, N=1 pour 2 ou 4 lignes),
    // et la taille des fontes (F=0 pour des cars 5x7, F=1 pour des cars 5x10).
     LCD_Cde(0x28); //0b00101000  2Line 5x8
     LCD_Cde(0x06) ; //  0b00000110) 0x06 if cursor inc and no display shift
     LCD_Cde(0x0C); // 0b00001100);   display ON, cursor ON, blink OFF
     Delay_20ms();
  }

void LCD_Put(char data)
{
     RS=1;
    __asm("NOP");
    En=0;
    PORT_Data &=0x0f;               //clear port
    PORT_Data|= data&0xf0;         //write upper nibble to port
    En = 1;                     // Clock the cmd in
     __delay_ms(1);
    En = 0;
    PORT_Data &= 0x0f;              //clear port
    PORT_Data |= (data<<4)&0xf0;	//shift left 4 times
    En = 1;
   // __delay_ms(1);
     __asm("NOP");
    En = 0;
}


void LCD_Print(char *str1)
{ char i=0;
    while( *(str1+i)>0 )    // Write String in RAM to LCD up to null
    {
        LCD_Put(*(str1+i));     // Write character to LCD
        i++;  
        if (i> (NbCarPL-1)) break;
    }
}
