
/*
 *version optimise avec advisor  optimisation level=0 -> level 2 
 * gagne 4 Bytes sur 68 ... OK 
 *06-07-2024
 * File:   main.c
 * Author: Paul
 */
// PIC16F84 mont sur carte BlueBird Electronics PCB053  4MHz
// programmateur POK508  aliment en 12V DC
// liaison DB9 F POK508 --- DB9 Male TU-S9 Trend interface RS232/USB 
// verifier que le port virtuel soit declare en #PORT < 4
// voir     as16f684_legacy.h pour les Mnemoniques
// pack,PIC16Fxxx_DFP,1.3.42,Microchip
// xc8\v2.36


//06/07/2024
// PIC 16F84 mont sur mini breadboard, avec quartz de 8Mhz
// PIC aliment via alim externe : le +5V USB du cordon prolific
// Pickit4 connect as usual
// chargement du programme ..OK en quelques secondes ..run OK

#define VERSION "20240714"
// modif init LCD

//#define VERSION "20240711"
#define With_LCD
//#define With_UART3
// avec LCD
// Erasing...
// [config mem] 0x2007, expected 0x3fff, got 0x0.
// Programming did not complete.
// attention : deconnecter RB6 RB7 sur le LCD ..conflit avec PickiT4
//#define VERSION "20240707"
//avec  uart3 seulement


#include <xc.h>
#define _16F684
#include <builtins.h>
#include <__at.h>
#define _XTAL_FREQ 8000000         
// Quartz 8Mhz encadr par 2x22pF sur mini breadboard
// was #define _XTAL_FREQ 4000000   
// filtre ceramique sur carte BlueBird Electronics PCB053
// programmateur POK508 et icprog105d.exe
//2007  CONFIG  3FF1  FOSC=XT

#pragma config FOSC = XT        // Oscillator Selection bits (XT oscillator)
#pragma config WDTE = OFF       // Watchdog Timer (WDT disabled)
#pragma config PWRTE = OFF       // Power-up Timer Enable bit (Power-up Timer is enabled)
#pragma config CP = OFF         // Code Protection bit (Code protection disabled

#define Byte uint8_t
#define Word uint16_t

#define  CR 13
#define  LF 10

#define  TX3            PORTAbits.RA2          // for UART3
#define  TX3_Pin_Dir    TRISAbits.TRISA2       // for UART3
#define  LED_Dir        TRISAbits.TRISA3
#define  LED            PORTAbits.RA3
#define  DHT22_Pin      PORTAbits.RA0 
#define  DHT22_Pin_Dir  TRISAbits.TRISA0

#include <__at.h>


#ifdef With_LCD
#include "LCD_2x16_lib_X.h"
#endif


 #define bit_set(var,bitno) ((var) |= 1 << (bitno))
 #define bit_clear(var,bitno) ((var) &= ~(1 << (bitno)))
/*
Byte  c3       __at (0x0020);
Byte RS_Count  __at (0x0021);
Byte  RS_tmp   __at (0x0022);
Byte RS_Delay  __at (0x0023);
 * */
   
int i,j;
Byte Texte[18];  
unsigned char Time_out ;
unsigned char T_byte1, T_byte2, RH_byte1, RH_byte2, CheckSum ;
unsigned int Temp, RH;

void Start_signal(void);
unsigned char Read_Donnee(void);
char check_response(void);
void strConstRamCpy(unsigned char *dest, const char *source);


/*
void UART3_Write(uint8_t cc)      // 16MHz 19200 bauds
{
   c3=~cc;    // complement du caractere !
    // avec TX3_PIN => RA2
 __asm("    movlw   8 ");
  __asm("   movwf   _RS_Count");
 __asm("    bcf     PORTA,2 ");
  __asm("   call    RSdelai2");
 __asm(" L00:");
 __asm("    rrcf    _c3,1 ");      
 __asm("    btfsc   STATUS,0 ");    
 __asm("    goto    L10    ");  
 __asm("    bsf     PORTA,2  "); 
 __asm("    goto    L20    ");   
 __asm(" L10:");
 __asm("    bcf     PORTA,2  ");    
 __asm(" L20:");
 __asm("    call    RSdelai2  ");        
 __asm("    decfsz  _RS_Count,1 ");  
 __asm("    goto    L00     ");       
 __asm("    bsf     PORTA,2   ");     
 __asm("    call    RSdelai2   ");   
 __asm("    call    RSdelai2  ");   
 __asm("    goto    LA1");
 __asm(" RSdelai2: "); 
 __asm("    MOVLW 28 ");
 __asm("    MOVWF _RS_tmp ");
 __asm(" RS00:");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    DECFSZ _RS_tmp,F ");
 __asm("    GOTO   RS00 ");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    NOP");
 __asm("    RETURN ");
__asm("  LA1:  ");
 __asm("    nop");
 }
  */   

void strConstRamCpy(unsigned char *dest, const char *source)
 { // --- Copie le texte depuis FLASH ROM vers RAM
  while (*source)
  {
      *dest++ = *source++ ;
  }   
  *dest = 0 ;    // terminateur
}

void Delay_2sec()
 {
  __delay_ms(2000);
  }
 

void Delay_500ms()
{
__delay_ms(500);
}

void Delay_20ms()
{
 __delay_ms(20);
}

void Start_signal()
{
  DHT22_Pin_Dir = 0;
  TRISAbits.TRISA0=0;// Configure connection pin as output
  PORTAbits.RA0=0;
  //DHT22_Pin = 0;                        // Connection pin output low
 Delay_20ms();
  PORTAbits.RA0=1;
  //DHT22_Pin = 1;                        // Connection pin output high
 __delay_us(30);
  DHT22_Pin_Dir = 1;              // Configure connection pin as input
}

 char check_response()
{
 __delay_us(40);
 if(! PORTAbits.RA0)
 // if(!DHT22_Pin)
  {                     // Read and test if connection pin is low
   __delay_us(80);
    if(PORTAbits.RA0)
        //if(DHT22_Pin)
    {                    // Read and test if connection pin is high
     __delay_us(50);
      return (1);
     }
    }
}


unsigned char Read_Donnee()
{
  unsigned char i, k, _Donnee;
  _Donnee= 0;     // k is used to count 1 bit reading duration
  Time_out=0;
  //  break;
  for(i = 0; i < 8; i++)
  { k = 0;
   while(! PORTAbits.RA0)
    {  k++;
      if (k > 100) 
      {
          Time_out = 1;
         break;
      }
     //__delay_us(1);
      __asm("NOP");
      __asm("NOP");
      __asm("NOP");
      __asm("NOP");
     }
 __delay_us(30);
  if(! PORTAbits.RA0)
      bit_clear(_Donnee, (7 - i));               // Clear bit (7 - i)
    else
    {
      bit_set(_Donnee, (7 - i));                 // Set bit (7 - i)
      k=0;
     while( PORTAbits.RA0)
     {                         // Wait until pin goes low
      k++;
      if (k > 100) 
      {
          Time_out = 1;
          break;
        }
      __asm("NOP");
      __asm("NOP");
      __asm("NOP");
      __asm("NOP");
      
    //__delay_us(1);
     }
     }
  }
  return _Donnee;
}

 

 void main()
 {
 
  PORTA = 0b00000001;
  TRISA = 0b00000001 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3,4,5=Digital output
  TRISB = 0b00000000 ;
  PORTA=0;
  LED_Dir=0;
  LED=0;
  DHT22_Pin_Dir =0;
  for (i=0;i<sizeof(Texte)-1;i++) Texte[i]=0;
  // pour UART3
#ifdef With_UART3
   TX3_Pin_Dir=0;
   TX3=1;
   c3=0;
   RS_Count=0;
   RS_tmp=0;
   RS_Delay=0;

 __asm(" CLRWDT ;Clear WDT and  prescaler");
 __asm("BSF STATUS, 5");
 __asm("MOVLW 0x01");
 __asm("MOVWF OPTION_REG ");
 __asm("BCF STATUS, 5 ");

#endif    
        
 // OPTION REG 0x81
 // RBPU INTEDG T0CS T0SE PSA PS2 PS1 PS0
  //   OPTION_REG=0x07; //b00000001;   Prescaler =256 
  //  OPTION_REG=0x00; //(par defaut) FOSC/(4x2) => 8/8= 1S 
   OPTION_REG=0x02; //(par defaut) FOSC/(4x4) =>16/8= 2S 
  

  Delay_2sec();
 
  #ifdef With_LCD
  Init_XC8_LCD ();
  strConstRamCpy(Texte,"16F84 at 8Mhz  ");
  LCD_Pos(1,0);
  LCD_Print(Texte);
  strConstRamCpy(Texte,"Mesure AM2302 ");
  LCD_Pos(2,0);
  LCD_Print(Texte);

   // __delay_ms(2000);
    Delay_2sec();
  #endif
    
 //   while(1);
 //}
 
 
  while(1)
   {
   Delay_500ms();
     #ifdef With_UART3
    j++;
    Texte[0]  = (j / 100) % 10  + 48;
    Texte[1]  = (j / 10) % 10  + 48;
    Texte[2] = j % 10  + 48;
    Texte[3] = ' ';
    Texte[4] =0;
    CPrint("j=");
    Print(Texte);
    #endif
     
     
 
     Start_signal();
    if(check_response())
    {                    // If there is response from sensor
      RH_byte1 = Read_Donnee();                 // read RH byte1
      RH_byte2 = Read_Donnee();                 // read RH byte2
      T_byte1 = Read_Donnee();                  // read T byte1
      T_byte2 = Read_Donnee();                  // read T byte2
      CheckSum = Read_Donnee();                 // read checksum
      if(Time_out){                           // If reading takes long time
         strConstRamCpy(Texte,"Time out!   ");
         LCD_Print(Texte);
      }
      else{
       if(CheckSum == ((RH_byte1 + RH_byte2 + T_byte1 + T_byte2) & 0xFF))
       {
        RH = RH_byte1;
        RH = (RH << 8) | RH_byte2;
        Temp = T_byte1;
        Temp = (Temp << 8) | T_byte2;
        if (Temp > 0x8000)
        {
         Texte[6] = '-';
         Temp = Temp & 0x7FFF; 
        }
        else
         strConstRamCpy(Texte, "Temp = 00.00 C  ");
         
          Texte[7]  = (Temp / 100) % 10  + 48;   //T_byte1 / 10  + '0';
          Texte[8]  = (Temp / 10) % 10  + 48;   //T_byte1 % 10  + '0';
          Texte[10] = Temp % 10  + 48;  //T_byte2 / 10  + '0';
          Texte[11] =223; // put degree symbol ()
          Texte[12]='C';
          Texte[13]=' ';
       //   Texte[15]=' ';
          Texte[16]=0;
           #ifdef With_UART3
          Print(Texte);
           #else
          LCD_Pos(1, 0);           // go to  row 1 column 0,
          LCD_Print(Texte);
        #endif
                              //1234567890123456
          strConstRamCpy(Texte,"RH   = 00.0%    ");
          Texte[7]     =  (RH / 100) % 10 + 48; //RH_byte1 / 10 + '0';
          Texte[8]     =  (RH / 10) % 10 + 48; //RH_byte1 % 10 + '0';
          Texte[10]    = RH % 10 + 48;
      //    Texte[11]    = '%';
      //    Texte[12]    = ' ';
      //    Texte[15]    = ' ';
          Texte[16]=0;
        #ifdef With_UART3
          Print(Texte);
        #else
          LCD_Pos(2, 0);           // go to Row 2, column 0
          LCD_Print(Texte);
        #endif
      }
      else {
          LCD_Cde(LCD_CLEAR);  
          LCD_Pos(1, 0);       
          strConstRamCpy(Texte,"Checksum Err");
            LCD_Print(Texte);
        }
      }
    }
    else 
    {
      strConstRamCpy(Texte,"no resp.from DHT");
        LCD_Print(Texte);
    }
  PORTAbits.RA3=1;
 
 for (i=0;i<6;i++)
  { 
     PORTAbits.RA3=0; Delay_500ms();
    PORTAbits.RA3=1;Delay_500ms();
   } 
  }
 }
 
 /*
  * Memory Summary:
    Program space        used   3E3h (   995) of   400h words   ( 97.2%)
    Data space           used    34h (    52) of    44h bytes   ( 76.5%)
    EEPROM space         used     0h (     0) of    40h bytes   (  0.0%)
    Configuration bits   used     1h (     1) of     1h word    (100.0%)
    ID Location space    used     0h (     0) of     4h bytes   (  0.0%)

   */